with Interfaces; use Interfaces;

package body CORBA_Repository_Root_FixedDef_Hash is

   P : constant array (0 .. 2) of Natural :=
     (2, 4, 7);

   T1 : constant array (0 .. 2) of Unsigned_8 :=
     (2, 4, 20);

   T2 : constant array (0 .. 2) of Unsigned_8 :=
     (2, 17, 8);

   G : constant array (0 .. 24) of Unsigned_8 :=
     (2, 0, 0, 0, 0, 0, 0, 0, 9, 11, 8, 0, 0, 0, 0, 5, 0, 6, 0, 7, 0, 11, 0,
      8, 8);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 25;
         F2 := (F2 + Natural (T2 (K)) * J) mod 25;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 12;
   end Hash;

end CORBA_Repository_Root_FixedDef_Hash;
